using System.ComponentModel;
using BTOps;

/// <summary>
/// Summary description for BTPipelineOperations
/// </summary>
[DataObject]
public class BTPipelineOperations
{
    [DataObjectMethod(DataObjectMethodType.Select, true)]
    public BTPipeline[] ListPipelines(string applicationName)
    {
        Operations btOps = new Operations();
        return btOps.Pipelines(applicationName, "");
    }

    [DataObjectMethod(DataObjectMethodType.Select, false)]
    public BTPipeline[] ListPipelineByName(string applicationName, string name)
    {
        Operations btOps = new Operations();
        return btOps.Pipelines(applicationName, name);
    }

    [DataObjectMethod(DataObjectMethodType.Select, false)]
    public BTPipeline[] ListReceivePipelines(string applicationName)
    {
        Operations btOps = new Operations();
        return btOps.PipelinesByType(applicationName, "Receive");
    }

    [DataObjectMethod(DataObjectMethodType.Select, false)]
    public BTPipeline[] ListSendPipelines(string applicationName)
    {
        Operations btOps = new Operations();
        return btOps.PipelinesByType(applicationName, "Send");
    }
}