//---------------------------------------------------------------------
// File: ServiceException.cs
// 
// Summary: Provides Exception Shielding exception, derived from System.Exception
//          Called from ExceptionShielding.CreateSoapException().  Used
//          to provide inner exception info for thrown SOAP Exception
//
//
//---------------------------------------------------------------------
// This file is part of the Microsoft ESB Guidance for BizTalk
//
// Copyright (c) Microsoft Corporation. All rights reserved.
//
// This source code is intended only as a supplement to Microsoft BizTalk
// Server 2006 R2 release and/or on-line documentation. See these other
// materials for detailed information regarding Microsoft code samples.
//
// THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
// KIND, WHETHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR
// PURPOSE.
//---------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Text;

namespace Microsoft.Practices.ESB.Exception.Management
{
    [Serializable]
    public class ServiceException : System.Exception
    {
        public ServiceException(string message)
            : base(message)
        {
        }
    }
}
